function $(element) {return document.getElementById(element);}

function log(str)
{
  var divName = "logOutput";
  var logOutput = $(divName);
  if(!logOutput){
    var logOutput = document.createElement('textarea');
    logOutput.setAttribute("cols", 120);
    logOutput.setAttribute("rows", 40);
    logOutput.setAttribute("id", divName);
    document.body.appendChild(logOutput);
  }
  //logOutput.innerHTML += str;
  logOutput.value+=str + "\n";
}

function dumpObject(o)
{
  var str = "type=" + typeof(o) + "\n";
  for (x in o){
    try{
        if(typeof(o[x])=="function")
            continue;
        str += x + ":" + o[x] + "\n";
    }catch(e){log("error :" + x);}
  }

  return str;
}

function extend(dest, src)
{
  for (var p in src)
    try{
        dest[p] = src[p];
    }catch(e){log("error :" + p);}
  return dest;
}
Object.prototype.extend = function(obj){return extend(this, obj);}



/**
* implement a JSP like template using javascript syntax
* [% %] is equivalent to <% %>
* [%= %] is equivalent to <%= %>
* alternative:  %{}, #{} will be equivalent to [%= %]
* and <!--%  %--> is equilent to [% %] to prevent some un-necessary XML escape of '<', etc symbol.
*
* To prevent browser escape special XML symbols, the template can be put inside <textarea> instead of <div>
* and user ${id}.value  to retrieve the original string.
*/
function JSPTemplate(_tmpl){
  this.tmpl = _tmpl.replace(/<!--%/mg, '[%').replace(/%-->/mg, '%]').replace(/%{([^}]*)}/mg, '[%=$1%]').replace(/#{([^}]*)}/mg, '[%=$1%]');
  this.tmpl = this.tmpl.replace(/=(\[%=[^%]*%\])/mg, "='$1'"); //fix for I.E., IE may remove quote for attribute values
  
  this.compile = function()
  {
    var re = /\[%([^%]*)%\]/mg;
    var lastIndex = 0;
    var code = '';
    var match;
    while((match = re.exec(this.tmpl)) != null){
      var matchedStr = match[1];
      code += 'result+=this.tmpl.substring(' + lastIndex + ',' + match.index + ');\n';
      if(matchedStr.charAt(0) == '=')
        code += 'result += ' + matchedStr.substring(1) + ';\n';
      else
        code += matchedStr;
      lastIndex = re.lastIndex;
    }
    code += 'result+=this.tmpl.substring(' + lastIndex + ');\n';
    return code;
  }
  this.code = this.compile(); 
  
  /** arg optional */
  this.evaluate = function (arg)
  {
    if(arg)
      extend(this, arg)
    //log(dumpObject(this));
    
    var result = '';
    eval(this.code);
    return result;
  }
  
  return this;
}

String.prototype.evaluate = function(obj){return new JSPTemplate(this).evaluate(obj);}

